<?php
// HELLO WORLD EXAMPLE DASHLET
//
// Copyright (c) 2008-2009 Nagios Enterprises, LLC.  All rights reserved.
//  
// $Id: helloworld.inc.php 9 2009-11-14 21:06:29Z egalstad $

include_once(dirname(__FILE__).'/../dashlethelper.inc.php');

// run the initialization function
helloworld_dashlet_init();

function helloworld_dashlet_init(){
	
	// respect the name!
	$name="helloworld";
	
	$args=array(

		// need a name
		DASHLET_NAME => $name,
		
		// informative information
		DASHLET_VERSION => "1.0",
		DASHLET_DATE => "09-22-2009",
		DASHLET_AUTHOR => "Nagios Enterprises, LLC",
		DASHLET_DESCRIPTION => "A test for a FUNCTION dashlet.  Function dashlets have the most power, compared to other types of dashlets.  They can do anything.  Hello world indeed.",
		DASHLET_COPYRIGHT => "Copyright (c) 2009 Nagios Enterprises",
		DASHLET_LICENSE => "BSD",
		DASHLET_HOMEPAGE => "http://www.nagios.com",
		
		// the good stuff - only one output method is used.  order of preference is 1) function, 2) url
		DASHLET_FUNCTION => "helloworld_dashlet_func",
		//DASHLET_URL => get_dashlet_url_base($name)."/$name.php",
		
		DASHLET_TITLE => "Hello World!",
		
		DASHLET_OUTBOARD_CLASS => "helloworld_outboardclass",
		DASHLET_INBOARD_CLASS => "helloworld_inboardclass",
		DASHLET_PREVIEW_CLASS => "helloworld_previewclass",
		
		DASHLET_CSS_FILE => "helloworld.css",
		//DASHLET_JS_FILE => "helloworld.js",

		DASHLET_WIDTH => "350px",
		DASHLET_HEIGHT => "60px",
		DASHLET_OPACITY => "0.5",
		DASHLET_BACKGROUND => "",

//		DASHLET_REFRESHRATE => -1,
		);
	register_dashlet($name,$args);
	}
	
function helloworld_dashlet_func($mode=DASHLET_MODE_PREVIEW,$id="",$args=null){
	$output="";

	switch($mode){
		case DASHLET_MODE_GETCONFIGHTML:
			break;
		case DASHLET_MODE_OUTBOARD:
			$output="<b>Hello World!</b> I'm a dashlet that outside a dashboard, but still in a page.  Cool.";
			break;
		case DASHLET_MODE_INBOARD:
			$output="<b>Hello World!</b> I'm a dashlet.  Dashlet <b>".$id."</b>, in fact. It looks like you attached me to one of your dashboards.  I've never felt so appreciated as I do now.";
			break;
		case DASHLET_MODE_PREVIEW:
			$output="<b>Hello World!</b> I'm a dashlet.  That means you're able to attach me to dashboards.  Try me out!";
			break;
		}
	$output.="<p>MODE: $mode, ID: $id</p>";
		
	return $output;
	}

?>