<?php
//
// Copyright (c) 2008-2009 Nagios Enterprises, LLC.  All rights reserved.
//  
// $Id: page-home.php 24 2009-12-16 16:14:21Z egalstad $

require_once(dirname(__FILE__).'/common.inc.php');

// check authentication
check_authentication();

route_request();

function route_request(){
	global $request;
	
	draw_page();
	}

function draw_page(){
	global $lstr;
	
	do_page_start(array("page_id"=>"home-page"));
?>
	<div id="leftnav">
	<?php draw_menu();?>
	</div>

	<div id="maincontent">
	<IFRAME src="<?php echo get_window_frame_url(get_base_url()."/includes/page-home-main.php");?>" width="100%" frameborder="0" id="maincontentframe" name="maincontentframe">
	[Your user agent does not support frames or is currently configured not to display frames. ]
	</IFRAME>
	<div id="viewtools">
	<div id="popout">
	<a href="#"><img src="<?php echo get_base_url();?>/images/popout.png" border="0" alt="<?php echo $lstr['PopoutAlt'];?>" title="<?php echo $lstr['PopoutAlt'];?>"></a>
	</div>
	<div id="addtomyviews">
	<a href="#"><img src="<?php echo get_base_url();?>/images/addtomyviews.png" border="0" alt="<?php echo $lstr['AddToMyViewsAlt'];?>" title="<?php echo $lstr['AddToMyViewsAlt'];?>"></a>
	</div>
	</div>
	</div>

<?	
	do_page_end();
	}

function draw_menu(){
	$m=get_menu_items();
	draw_menu_items($m);
?>

<?php
	}
	

function get_menu_items(){
	global $lstr;

	$base_path=get_base_url();
	$includes_path=$base_path."includes/";
	$components_path=$includes_path."components/";

	$xistatus_path=$components_path."xicore/status.php";
	$nagioscoreui_path=nagioscore_get_ui_url();

	
	$mi=array();
	
	$usenew=false;
	
		
	// use old (Nagios Core) interface
	if(1){
		// Quick View
		$mi[]=array(
			"type" => "menusection",
			"title" => "Quick View",
			"opts" => array(
				"id" => "quickview",
				"expanded" => true,
				"url" => $nagioscoreui_path."tac.php"
				)
			);
		$mi[]=array(
			"type" => "link",
			"title" => "Home Dashboard",
			"opts" => array(
				"href" => get_base_url()."/includes/page-home-main.php"
				)
			);
		$mi[]=array(
			"type" => "linkspacer"
			);
		$mi[]=array(
			"type" => "link",
			"title" => "Tactical Overview",
			"opts" => array(
				"href" => $nagioscoreui_path."tac.php"
				)
			);
		$mi[]=array(
			"type" => "linkspacer"
			);
		$mi[]=array(
			"type" => "link",
			"title" => "Open Service Problems",
			"opts" => array(
				//"href" => $nagioscoreui_path."status.php?host=all&type=detail&servicestatustypes=61&serviceprops=10&hostprops=10"
				"href" => $xistatus_path."?show=services&hoststatustypes=".HOSTSTATE_UP."&servicestatustypes=".(SERVICESTATE_WARNING|SERVICESTATE_UNKNOWN|SERVICESTATE_CRITICAL)."&serviceattr=".(SERVICESTATUSATTR_NOTACKNOWLEDGED|SERVICESTATUSATTR_NOTINDOWNTIME)
				)
			);
		$mi[]=array(
			"type" => "link",
			"title" => "Open Host Problems",
			"opts" => array(
				//"href" => $nagioscoreui_path."status.php?host=all&type=detail&servicestatustypes=61&serviceprops=10&hostprops=10"
				"href" => $xistatus_path."?show=hosts&hoststatustypes=".(HOSTSTATE_DOWN|HOSTSTATE_UNREACHABLE)."&hostattr=".(HOSTSTATUSATTR_NOTACKNOWLEDGED|HOSTSTATUSATTR_NOTINDOWNTIME)
				)
			);
		$mi[]=array(
			"type" => "linkspacer"
			);
		$mi[]=array(
			"type" => "link",
			"title" => "All Service Problems",
			"opts" => array(
				//"href" => $nagioscoreui_path."status.php?host=all&servicestatustypes=28"
				"href" => $xistatus_path."?show=services&servicestatustypes=".(SERVICESTATE_WARNING|SERVICESTATE_UNKNOWN|SERVICESTATE_CRITICAL)
				)
			);
		$mi[]=array(
			"type" => "link",
			"title" => "All Host Problems",
			"opts" => array(
				//"href" => $nagioscoreui_path."status.php?hostgroup=all&style=hostdetail&hoststatustypes=12"
				"href" => $xistatus_path."?show=hosts&hoststatustypes=".(HOSTSTATE_DOWN|HOSTSTATE_UNREACHABLE)
				)
			);
		if(is_authorized_for_all_objects()==true){
			$mi[]=array(
				"type" => "linkspacer"
				);
			$mi[]=array(
				"type" => "link",
				"title" => "Network Outages",
				"opts" => array(
					//"href" => $nagioscoreui_path."outages.php"
					"href" => get_network_outages_link()
					)
				);
			}
		$mi[]=array(
			"type" => "linkspacer"
			);
		$mi[]=array(
			"type" => "linkspacer"
			);
		$searchstring=$lstr['SearchBoxText'];
		$mi[]=array(
			"type" => "html",
			"title" => "Quick Find",
			"opts" => array(
				"html" => '
				<li>
				<div>
				<form method="post" target="maincontentframe" action="'.$xistatus_path."?show=services".'">
				<input type="hidden" name="navbarsearch" value="1" />
				<label for="navbarSearchBox">'.$lstr['QuickFind'].':</label><br class="nobr" />
				<input type="text" size="12" name="search" id="navbarSearchBox" value="'.$searchstring.'" />
				<input type="submit" class="submitbutton" name="searchButton" value="'.$lstr['GoButton'].'" id="searchButton" style="margin: 0px;">
				</form>
				</div>
				</li>
				',
				)
			);			
		$mi[]=array(
			"type" => "menusectionend",
			"title" => "",
			"opts" => ""
			);
			
		// Detail
		$mi[]=array(
			"type" => "menusection",
			"title" => "Details",
			"opts" => array(
				"id" => "statusdetails",
				"expanded" => true,
				//"url" => $nagioscoreui_path."status.php?host=all"
				"url" => $xistatus_path."?show=services"
				)
			);
		$mi[]=array(
			"type" => "link",
			"title" => "Service Detail",
			"opts" => array(
				//"href" => $nagioscoreui_path."status.php?host=all"
				"href" => $xistatus_path."?show=services"
				)
			);
		$mi[]=array(
			"type" => "link",
			"title" => "Host Detail",
			"opts" => array(
				//"href" => $nagioscoreui_path."status.php?hostgroup=all&style=hostdetail"
				"href" => $xistatus_path."?show=hosts"
				)
			);
		$mi[]=array(
			"type" => "linkspacer"
			);
		$mi[]=array(
			"type" => "link",
			"title" => "Hostgroup Summary",
			"opts" => array(
				//"href" => $nagioscoreui_path."status.php?hostgroup=all&style=summary"
				"href" => get_hostgroup_status_link("all","summary")
				)
			);
		$mi[]=array(
			"type" => "link",
			"title" => "Hostgroup Overview",
			"opts" => array(
				//"href" => $nagioscoreui_path."status.php?hostgroup=all&style=overview"
				"href" => get_hostgroup_status_link("all","overview")
				)
			);
		$mi[]=array(
			"type" => "link",
			"title" => "Hostgroup Grid",
			"opts" => array(
				//"href" => $nagioscoreui_path."status.php?hostgroup=all&style=grid"
				"href" => get_hostgroup_status_link("all","grid")
				)
			);
		$mi[]=array(
			"type" => "linkspacer"
			);
		$mi[]=array(
			"type" => "link",
			"title" => "Servicegroup Summary",
			"opts" => array(
				//"href" => $nagioscoreui_path."status.php?servicegroup=all&style=summary"
				"href" => get_servicegroup_status_link("all","summary")
				)
			);
		$mi[]=array(
			"type" => "link",
			"title" => "Servicegroup Overview",
			"opts" => array(
				//"href" => $nagioscoreui_path."status.php?servicegroup=all&style=overview"
				"href" => get_servicegroup_status_link("all","overview")
				)
			);
		$mi[]=array(
			"type" => "link",
			"title" => "Servicegroup Grid",
			"opts" => array(
				//"href" => $nagioscoreui_path."status.php?servicegroup=all&style=grid"
				"href" => get_servicegroup_status_link("all","grid")
				)
			);
		$mi[]=array(
			"type" => "menusectionend",
			"title" => "",
			"opts" => ""
			);
			
		// Performance Graphs
		$mi[]=array(
			"type" => "menusection",
			"title" => "Performance Graphs",
			"opts" => array(
				"id" => "perfgraphs",
				"expanded" => true,
				"url" => $base_path."perfgraphs/"
				)
			);
		$mi[]=array(
			"type" => "link",
			"title" => "All Graphs",
			"opts" => array(
				"href" => $base_path."perfgraphs/"
				)
			);
		$mi[]=array(
			"type" => "menusectionend",
			"title" => "",
			"opts" => ""
			);
			
			
		// Maps
		$mi[]=array(
			"type" => "menusection",
			"title" => "Maps",
			"opts" => array(
				"id" => "maps",
				"expanded" => false,
				//"url" => $nagioscoreui_path."statusmap.php"
				"url" => get_statusmap_link()
				)
			);
		$mi[]=array(
			"type" => "link",
			"title" => "Network Status Map",
			"opts" => array(
				//"href" => $nagioscoreui_path."statusmap.php"
				"href" => get_statusmap_link()
				)
			);
		$mi[]=array(
			"type" => "menusectionend",
			"title" => "",
			"opts" => ""
			);
			

		// Incident Management
		$mi[]=array(
			"type" => "menusection",
			"title" => "Incident Management",
			"opts" => array(
				"id" => "incidentmanagement",
				"expanded" => false,
				//"url" => $nagioscoreui_path."extinfo.php?type=3"
				"url" => $xistatus_path."?show=comments"
				)
			);
		$mi[]=array(
			"type" => "link",
			"title" => "Acknowledgements",
			"opts" => array(
				//"href" => $nagioscoreui_path."extinfo.php?type=3"
				"href" => $xistatus_path."?show=comments"
				)
			);
		$mi[]=array(
			"type" => "link",
			"title" => "Scheduled Downtime",
			"opts" => array(
				"href" => $nagioscoreui_path."extinfo.php?type=6"
				)
			);
		$mi[]=array(
			"type" => "link",
			"title" => "Notifications",
			"opts" => array(
				"href" => $nagioscoreui_path."notifications.php?contact=all"
				)
			);
		$mi[]=array(
			"type" => "menusectionend",
			"title" => "",
			"opts" => ""
			);
			

		if(is_authorized_for_monitoring_system()==true){

			// Process Info
			$mi[]=array(
				"type" => "menusection",
				"title" => "Monitoring Process",
				"opts" => array(
					"id" => "system",
					"expanded" => false,
					//"url" => $nagioscoreui_path."extinfo.php?type=0"
					"url" => $xistatus_path."?show=process"
					)
				);
			$mi[]=array(
				"type" => "link",
				"title" => "Process Info",
				"opts" => array(
					//"href" => $nagioscoreui_path."extinfo.php?type=0"
					"href" => $xistatus_path."?show=process"
					)
				);
			$mi[]=array(
				"type" => "link",
				"title" => "Performance",
				"opts" => array(
					//"href" => $nagioscoreui_path."extinfo.php?type=4"
					"href" => $xistatus_path."?show=performance"

					)
				);

			$mi[]=array(
				"type" => "link",
				"title" => "Event Log",
				"opts" => array(
					"href" => $nagioscoreui_path."showlog.php"
					)
				);
			$mi[]=array(
				"type" => "menusectionend",
				"title" => "",
				"opts" => ""
				);
			}
	
		}
		

	/*
	// Addons
	$mi[]=array(
		"type" => "menusection",
		"title" => "Addons",
		"opts" => array(
			"id" => "system",
			"expanded" => false,
			//"url" => $includes_path."page-subcomponents-main.php",
			)
		);
	$mi[]=array(
		"type" => "link",
		"title" => "Nagios Core",
		"opts" => array(
			"href" => get_base_url()."?page=subcomponent-nagioscore",
			"target" => "_self",
			)
		);
	$mi[]=array(
		"type" => "menusectionend",
		"title" => "",
		"opts" => ""
		);
	*/

	return $mi;
	}
	

?>


